function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import { fork } from 'redux-saga/effects';
import wrapSagaSafely from './wrapSagaSafely';

var sagaHelpers = ['takeEvery', 'takeLatest', 'takeLatestPerKey'];

var forkSafely = function forkSafely(sagaHelper) {
	for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
		args[_key - 1] = arguments[_key];
	}

	if (sagaHelper.name === 'throttle') {
		var ms = args[0],
		    fn = args[1],
		    pattern = args[2],
		    saga = args[3],
		    rest = args.slice(4);


		return fork.apply(undefined, [sagaHelper, ms, fn, pattern, wrapSagaSafely(saga)].concat(_toConsumableArray(rest)));
	} else if (sagaHelpers.includes(sagaHelper.name)) {
		var _pattern = args[0],
		    _saga = args[1],
		    _rest = args.slice(2);

		return fork.apply(undefined, [sagaHelper, _pattern, wrapSagaSafely(_saga)].concat(_toConsumableArray(_rest)));
	}

	return fork.apply(undefined, [wrapSagaSafely(sagaHelper)].concat(args));
};

export default forkSafely;