import _regeneratorRuntime from 'babel-runtime/regenerator';
/* eslint max-statements: off, consistent-return: off */
import { call } from 'redux-saga/effects';
import { delay } from 'redux-saga';
import retryStrategies from './retryStrategies';

var withRetry = function withRetry() {
	var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	    _ref$baseDelay = _ref.baseDelay,
	    baseDelay = _ref$baseDelay === undefined ? 100 : _ref$baseDelay,
	    _ref$logFailures = _ref.logFailures,
	    logFailures = _ref$logFailures === undefined ? true : _ref$logFailures,
	    _ref$retryAttempts = _ref.retryAttempts,
	    retryAttempts = _ref$retryAttempts === undefined ? 5 : _ref$retryAttempts,
	    _ref$retryStrategy = _ref.retryStrategy,
	    retryStrategy = _ref$retryStrategy === undefined ? 'exponential' : _ref$retryStrategy;

	return function (fn) {
		return (/*#__PURE__*/_regeneratorRuntime.mark(function wrappedWithRetry() {
				for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
					args[_key] = arguments[_key];
				}

				var i, result;
				return _regeneratorRuntime.wrap(function wrappedWithRetry$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								i = 0;

							case 1:
								if (!(i < retryAttempts)) {
									_context.next = 20;
									break;
								}

								_context.prev = 2;
								_context.next = 5;
								return call.apply(undefined, [fn].concat(args));

							case 5:
								result = _context.sent;
								return _context.abrupt('return', result);

							case 9:
								_context.prev = 9;
								_context.t0 = _context['catch'](2);

								i += 1;

								if (logFailures) {
									console.log(_context.t0, fn, args);
								}

								if (!(i === retryAttempts)) {
									_context.next = 16;
									break;
								}

								_context.t0.fn = fn.toString();
								throw _context.t0;

							case 16:
								_context.next = 18;
								return delay(baseDelay * retryStrategies[retryStrategy](i));

							case 18:
								_context.next = 1;
								break;

							case 20:
							case 'end':
								return _context.stop();
						}
					}
				}, wrappedWithRetry, this, [[2, 9]]);
			})
		);
	};
};

export default withRetry;